package com.pixelized.server.lwa.server.rest.character

import com.pixelized.server.lwa.server.Engine
import com.pixelized.server.lwa.utils.extentions.create
import com.pixelized.server.lwa.utils.extentions.exception
import com.pixelized.shared.lwa.model.characterSheet.CharacterSheetJson
import com.pixelized.shared.lwa.protocol.rest.APIResponse
import com.pixelized.shared.lwa.protocol.websocket.ApiSynchronisation
import io.ktor.server.request.receive
import io.ktor.server.response.respond
import io.ktor.server.routing.RoutingContext

fun Engine.putCharacter(): suspend RoutingContext.() -> Unit {
    return {
        try {
            val form = call.receive<CharacterSheetJson>()
            val create = call.queryParameters.create
            characterService.save(
                character = form,
                create = create,
            )
            call.respond(
                message = APIResponse.success()
            )
            webSocket.emit(
                value = ApiSynchronisation.CharacterSheetUpdate(
                    timestamp = System.currentTimeMillis(),
                    characterSheetId = form.id,
                ),
            )
        } catch (exception: Exception) {
            call.exception(
                exception = exception
            )
        }
    }
}